﻿Imports System.ComponentModel
Imports System.Windows.Forms
Public Class TimerBeep

    ' miembros 
    Private m_frecuenciaBeep As Integer = 300
    ' para definir un valor predeterminado
    Private m_duraciónBeep As Integer = 500
    Private m_intervalo As Integer = 1000
    Private m_tiempoJuego As Integer = 30
    Private NumTick As Integer

    ' eventos
    ' el evento Empezar avisa al contendor que se ha hecho clic 
    ' en el botón Iniciar
    Event Empezar(ByVal sender As Object, _
  ByVal e As System.EventArgs)
    ' el evento Tiempo indica que se ha agotado el tiempo
    Event Tiempo(ByVal sender As Object, _
ByVal e As System.EventArgs)

    <DefaultValue(2000), _
 Description("Frecuencia del sonido beep en Herzios " & _
 "(entre 100 y   9000)")> _
    Public Property FrecuenciaBeep() As Integer
        ' frecuenciaBeep es la altura del sonido Beep

        Get
            Return m_frecuenciaBeep
        End Get
        Set(ByVal value As Integer)
            If value > 100 And value < 9000 Then
                m_frecuenciaBeep = value
            Else
                MessageBox.Show("FrecuenciaBeep debe ser " & _
    " mayor a 100 y menor que 9000")
            End If
        End Set

    End Property

    <Description("Duración de cada beep en ms")> _
    Public Property DuraciónBeep() As Integer
        ' DuraciónBeep indica el tiempo de cada Beep
        ' el valor en milisegundos

        Get
            Return m_duraciónBeep
        End Get
        Set(ByVal value As Integer)
            If value > 100 And value < m_intervalo Then
                m_duraciónBeep = value
            Else
                MessageBox.Show("DuraciónBeep debe ser " & _
    " mayor a 100 y menor que la propiedad " & _
    "IntervaloTick")
            End If
        End Set

    End Property

    <DefaultValue(1000), _
    Description("Intervalo entre cada Tick en ms")> _
    Public Property IntervaloTick() As Integer
        ' IntervaloTick indica cada cuánto tiempo se 
        ' produce un Tick
        ' el valor en milisegundos

        Get
            Return m_intervalo
        End Get
        Set(ByVal value As Integer)
            If value > 100 And value > m_duraciónBeep Then
                m_intervalo = value
            Else
                MessageBox.Show("IntervaloTick debe ser " & _
    "mayor a 100 y que la propiedad DuraciónBeep")
            End If
        End Set

    End Property
    <DefaultValue(30), _
    Description("Tiempo de juego en segundos")> _
    Public Property TiempoJuego() As Integer
        ' TiempoJuego indica la duración del juego
        ' esta propiedad se puede modificar como propiedad 
        ' o desde un
        ' cuadro de texto durante la ejecución

        Get
            Return m_tiempoJuego
        End Get
        Set(ByVal value As Integer)
            If value > m_intervalo / 1000 Then
                m_tiempoJuego = value
            Else
                MessageBox.Show("TiempoJuego (en segundos) " & _
    "debe ser mayor al IntervaloTick / 1000")
            End If
        End Set

    End Property

    Private Sub Button1_Click(ByVal sender As System.Object, _
        ByVal e As System.EventArgs) _
        Handles Button1.Click

        ' botón para iniciar y detener
        ' si el temporizador está activo
        ' el clic es para detener, 
        ' caso contrario, es para iniciar
        If Timer1.Enabled Then
            ' la interfaz queda preparada para
            ' el momento del inicio del crono
            detener()
        Else
            ' la interfaz queda preparada para
            ' el momento de la detención del crono
            iniciar()
            ' avisa que empieza la cuenta de tiempo
            RaiseEvent Empezar(Me, New System.EventArgs())
        End If
        ' Cuenta los Ticks
        NumTick = 0

    End Sub
    Private Sub iniciar()
        ' estado de los controles durante el juego

        Timer1.Interval = m_intervalo
        Timer1.Enabled = True
        Button1.Text = "Detener"
        TextBox1.Enabled = False

    End Sub

    Private Sub detener()
        ' estado de los controles al iniciar el juego

        Timer1.Enabled = False
        TextBox1.Enabled = True
        Button1.Text = "Iniciar"

    End Sub

    Private Sub Timer1_Tick(ByVal sender As Object, _
        ByVal e As System.EventArgs) _
        Handles Timer1.Tick

        ' En cada Tick se verifica si
        ' se ha agotado el tiempo de juego
        NumTick += 1
        Label1.Text = NumTick.ToString
        If NumTick >= m_tiempoJuego Then
            detener()

            ' cuando se acaba el juego se genera
            ' un beep más largo
            Console.Beep(Me.FrecuenciaBeep + 500, _
    Me.DuraciónBeep + 500)

            ' se genera un evento Tiempo para avisar 
            ' que se ha acabado el tiempo de juego
            RaiseEvent Tiempo(Me, New System.EventArgs())
        Else
            Console.Beep(Me.FrecuenciaBeep, Me.DuraciónBeep)
        End If

    End Sub
    Private Sub TextBox1_TextChanged(ByVal sender As Object, _
       ByVal e As System.EventArgs) _
       Handles TextBox1.TextChanged

        ' si se modifica el cuadro de texto TextBox1
        ' se actualiza la propiedad TiempoJuego

        Me.TiempoJuego = Val(TextBox1.Text)

    End Sub


End Class
