﻿Imports System.IO
Module Module1
    ' Unidad 10 Ej 07
    Sub Main()
        Dim fb As FileStream
        Dim fbw As BinaryWriter
        Dim fbr As BinaryReader
        ' longitud de cada registro
        Dim lReg As Integer = 66

        ' Variable  para entrada de datos
        Dim sDat As String

        ' Variable del nombre del archivo
        Dim sNom As String

        Dim ISh As Short
        Dim ILong As Long
        Dim Nombre As String = ""
        Dim Dirección As String = ""
        Dim Legajo As Integer

        ' Se encierra todo en un bloque Try 
        ' para gestionar los errores de modo personalizado
        Try
            ' Se obtiene el nombre del archivo
            Console.Write("Nombre del archivo:")
            sNom = Console.ReadLine()

            ' Crea un flujo de bytes para el archivo  
            ' modo OpenOrCreate: se abre y si no existe se crea   
            ' acceso: Write, para escritura y lectura

            fb = New FileStream(sNom, FileMode.OpenOrCreate, _
    FileAccess.ReadWrite)

            ' utilizo el objeto para crear un
            ' objeto BinaryWriter para escribir
            ' y el objeto BinaryReader para leer

            ' La codificación ASCII me asegura que todos los 
            ' códigos
            ' ocupan 1 byte
            ' Si eligiese UTF8 tendría que resolver que el flujo
            ' tendría longitud variable (una solución simple es
            ' generar un campo padding en cada registro)
            fbw = New BinaryWriter(fb, System.Text.Encoding.ASCII)
            fbr = New BinaryReader(fb, System.Text.Encoding.ASCII)

            Console.WriteLine("¿Número de secuencia? Fin (Intro)")
            sDat = Console.ReadLine()

            ' el bucle se ejecuta mientras no se 
            ' introduzca Intro sin datos
            While (sDat <> Nothing)

                ISh = Convert.ToInt16(sDat)
                ' cada registro tiene 66 bytes (31 + 31 + 4)
                ' por lo que el desplazamiento es ILong
                ILong = ISh * lReg

                ' Si ILong se va fuera de los límites no hay datos

                If ILong < fbw.BaseStream.Length Then
                    ' en este caso:
                    ' el posicionamiento se calcula 
                    '  desde el comienzo
                    fbr.BaseStream.Seek(ILong, SeekOrigin.Begin)

                    ' Leo los campoos del registro
                    ' ¡en el orden correcto!
                    Nombre = fbr.ReadString()
                    Dirección = fbr.ReadString()
                    Legajo = fbr.ReadInt32()
                Else
                    ' si no hay datos: limpio campos
                    Nombre = ""
                    Dirección = ""
                    Legajo = 0
                End If

                ' Muestra los datos vigentes

                Console.WriteLine("Nombre: {0}", Nombre)
                Console.WriteLine("Dirección: {0}", Dirección)
                Console.WriteLine("Legajo: {0}", Legajo)

                ' Permite la modificación
                ' o la inserción de nuevos campos
                ' según sea un registro viejo o nuevo

                ' Si el campo no cambia: pulsar Intro
                Console.WriteLine("Nuevos datos o Intro")

                ' Posicionamiento, pero con el flujo
                ' de salida
                fbw.BaseStream.Seek(ILong, SeekOrigin.Begin)

                Console.Write("Nombre:")
                ' Obtiene el campo Nombre
                sDat = Console.ReadLine()
                If (sDat.Length > 0) Then
                    ' ajusta la longitud: debe ser fija a 30
                    Nombre = Ajustar(sDat)
                Else
                    Nombre = Ajustar(Nombre)
                End If
                ' escribe el campo
                fbw.Write(Nombre)

                Console.Write("Dirección:")
                ' Obtiene la dirección
                sDat = Console.ReadLine()
                If (sDat.Length > 0) Then
                    '  ajusta la longitud: debe ser fija a 30
                    Dirección = Ajustar(sDat)
                Else
                    Dirección = Ajustar(Dirección)
                End If
                ' escribe el campo Dirección 
                fbw.Write(Dirección)

                Console.Write("Legajo:")
                sDat = Console.ReadLine()
                ' Obtiene el campo Legajo
                If (sDat.Length > 0) Then
                    Legajo = Convert.ToInt32(sDat)
                End If
                ' escribe el campo Legajo
                fbw.Write(Legajo)

                ' fuerza la escritura en este momento
                fbw.Flush()

                Console.WriteLine("¿Otro registro? Fin (Intro)")
                sDat = Console.ReadLine()

            End While


        Catch ex As IOException
            Console.WriteLine("Se detecta un error IO " + _
     ex.Message)
        Catch ex As Exception
            Console.WriteLine("Se detecta un error genérico " + _
     ex.Message)

        Finally
            ' Cerrar el flujo de datos que utiliza el archivo
            If (Not fbw Is Nothing) Then fbw.Close()
            If (Not fbr Is Nothing) Then fbr.Close()
            If (Not fb Is Nothing) Then fb.Close()

        End Try
        Console.Read()

    End Sub
    Public Function Ajustar(ByVal a As String) As String
        ' ajusta la longitud del campo a 30 caracteres
        a = a.PadRight(30)
        Ajustar = a.Substring(0, 30)
        Return Ajustar
    End Function


End Module
