﻿Imports System.Drawing
Imports System.Drawing.Printing
Imports System.Drawing.Font
Imports System.IO

Module Module1
    ' Unidad 10 Ej 08
    Dim flujo As StreamReader
    Dim letra As Font
    Dim formato As StringFormat

    Sub Main()
        Dim sNom As String
        Dim impre As PrintDocument

        Console.Write("Archivo de texto que se quiere imprimir:")
        sNom = Console.ReadLine()

        Try ' este bloque Try controla 
            ' errores dentro del proceso del flujo
            ' se crea el flujo de datos de entrada
            flujo = New StreamReader(sNom)

            Try ' este bloque Try controla errores 
                ' dentro de la impresión

                ' define la fuente que utilizará la página
                letra = New Font("Times New Roman", 8)

                ' crea el objeto PrintDocument
                impre = New PrintDocument

                ' define quién gestionará el evento PrintPage
                ' en este caso, nuestra función Imprimir()
                AddHandler impre.PrintPage, AddressOf Imprimir

                ' llamar al método Print
                impre.Print()

            Catch ex As Exception
                Console.WriteLine("error en proceso pre impresión")
            Finally
                ' cierra el flujo de entrada
                flujo.Close()
            End Try

        Catch ex As Exception
            Console.WriteLine("error en creación objeto " & _
     "StreamReader")
        End Try

    End Sub

    ' el evento PrintPage provoca la ejecución
    ' del método Imprimir
    Public Sub Imprimir(ByVal oVar As Object, _
  ByVal ev As PrintPageEventArgs)

        Dim sLin As String ' área de lectura del flujo de datos
        Dim qLineas As Short ' cantidad de líneas por página
        Dim qSumaLineas As Short ' nro. de línea impresa
        Dim puntoY As Single ' coordenada Y
        Dim puntoX As Single ' coordenada X

        Try
            ' calcula cuántas líneas entran en la página
            qLineas = ev.MarginBounds.Height / _
    letra.GetHeight(ev.Graphics)

            sLin = flujo.ReadLine()
            While (qSumaLineas < qLineas And (Not sLin Is Nothing))
                ' calcula la coordenada Y del documento vigente 
                puntoY = ev.MarginBounds.Top + _
                              (qSumaLineas * _
      letra.GetHeight(ev.Graphics))
                ' calcula la coordenada X
                puntoX = ev.MarginBounds.Left

                formato = New StringFormat

                ' dibuja la cadena de texto con la letra elegida
                ' en color negro, en la corredenada x y
                ' y con un formato estándar
                ev.Graphics.DrawString(sLin, _
                                    letra, _
                                    Brushes.Black, _
                                    puntoX, _
                                    puntoY, _
                                    formato)

                qSumaLineas += 1
                sLin = flujo.ReadLine()
            End While

            ' si salió del bucle While porque el flujo
            ' de datos se ha acabado entonces no quedan
            ' páginas pendiente
            ' en caso contrario, se provoca un nuevo evento
            ' PrintPage
            If (sLin Is Nothing) Then
                ev.HasMorePages = False
            Else
                ' habrá otro evento PrintPage
                ev.HasMorePages = True
            End If
        Catch ex As Exception
            Console.WriteLine("error en proceso de impresión")

        End Try

    End Sub

End Module
