﻿Module Module1
    ' Unidad 11 Ej 01
    ' el módulo utiliza un termostato para saber   
    ' cuándo activar o desactivar un ventilador

    ' el módulo se suscribe a los eventos de la clase
    ' Termostato
    ' define un Termostato Privado y con eventos
    Private WithEvents cl As Termostato
    Dim var As Decimal
    Sub Main()
        ' temperatura inicial 27 grados
        Dim term As New Termostato(Date.Now, 27)
        Dim i As Integer

        cl = term
        ' Se simulan 8 controles de temperatura
        ' en cada control se informa la variación de temperatura
        ' entre control y control

        For i = 1 To 8
            Console.WriteLine("Control {0}", i)
            Console.WriteLine("Hora actual {0} Temperatura " & _
    " actual {1}", cl.Hora, cl.Temperatura)

            cl.VerificarTemperatura()

            Console.WriteLine("*******")
        Next i
        Console.ReadLine()
    End Sub

    Private Sub cl_EscasaTemperatura(ByVal Sender As Termostato, _
    ByVal e As System.EventArgs) _
    Handles cl.EscasaTemperatura

        ' aquí se supone que el programa puiede actuar sobre un 
        ' interruptor del ventilador

        Console.WriteLine("SE DETIENE EL VENTILADOR")
        ' suponemos que mientras esté detenido el ventilador
        ' la temperatura sube 4 grados entre control y control
        cl.Variación = +4

    End Sub


    Private Sub cl_ExcesoTemperatura(ByVal Sender As Termostato, _
    ByVal e As System.EventArgs) _
    Handles cl.ExcesoTemperatura

        ' aquí se supone que el programa puiede actuar sobre un 
        ' interruptor del ventilador

        Console.WriteLine("SE PONE EN MARCHA EL VENTILADOR")
        ' suponemos que mientras esté en marcha el ventilador
        ' la temperatura baja 3 grados entre control y control
        cl.Variación = -3

    End Sub

End Module

Public Class Termostato
    ' la clase Termostato genera eventos cuando
    ' se sobrepasan los límites de temperatura

    Private m_Hora As Date
    Private m_Temp As Decimal
    Private m_Var As Decimal
    Private Const LIMITSUP As Decimal = 25D
    Private Const LIMITINF As Decimal = 21D

    Public Event ExcesoTemperatura(ByVal Sender As Termostato, _
       ByVal e As EventArgs)
    Public Event EscasaTemperatura(ByVal Sender As Termostato, _
      ByVal e As EventArgs)

    Public Sub New(ByVal aHora As Date, ByVal aTemp As Decimal)
        m_Hora = aHora
        m_Temp = aTemp
    End Sub

    ReadOnly Property Hora() As Date
        Get
            Return m_Hora
        End Get
    End Property

    ReadOnly Property Temperatura() As Decimal
        Get
            Return m_Temp
        End Get
    End Property

    Public Property Variación() As Decimal
        Get
            Return m_Var
        End Get
        Set(ByVal valor As Decimal)
            m_Var = valor
        End Set
    End Property

    Public Sub VerificarTemperatura()
        m_Temp = m_Temp + m_Var
        m_Hora = Date.Now
        If (m_Temp > LIMITSUP) Then
            'demasiada temperatura
            RaiseEvent ExcesoTemperatura(Me, New System.EventArgs())
        ElseIf (m_Temp < LIMITINF) Then
            'poca temperatura
            RaiseEvent EscasaTemperatura(Me, New System.EventArgs())
        Else
            ' rango de temperatura correcto
            ' no se genera ningún evento
        End If

    End Sub

End Class
