﻿Module Module1
    ' Unidad 11 Ej 01
    ' el módulo utiliza un termostato para saber   
    ' cuándo activar o desactivar un ventilador

    ' el módulo se suscribe a los eventos de la clase
    ' Termostato
    ' define un Termostato Privado y con eventos
    Private WithEvents cl As Termostato
    Dim var As Decimal
    Sub Main()
        ' temperatura inicial 27 grados
        Dim term As New Termostato(Date.Now, 27)
        Dim i As Integer

        cl = term
        ' Se simulan 8 controles de temperatura
        ' en cada control se informa la variación de temperatura
        ' entre control y control

        For i = 1 To 8
            Console.WriteLine("Control {0}", i)
            Console.WriteLine("Hora actual {0} Temperatura " & _
    " actual {1}", cl.Hora, cl.Temperatura)

            cl.VerificarTemperatura()

            Console.WriteLine("*******")
        Next i
        Console.ReadLine()
    End Sub

    Private Sub cl_EscasaTemperatura(ByVal Sender As Termostato, _
    ByVal e As System.EventArgs) _
    Handles cl.EscasaTemperatura

        ' aquí se supone que el programa puiede actuar sobre un 
        ' interruptor del ventilador

        Console.WriteLine("SE DETIENE EL VENTILADOR")
        ' suponemos que mientras esté detenido el ventilador
        ' la temperatura sube 4 grados entre control y control
        cl.Variación = +4

    End Sub


    Private Sub cl_ExcesoTemperatura(ByVal Sender As Termostato, _
     ByVal e As EventoDesvío) _
     Handles cl.ExcesoTemperatura

        ' aquí se supone que el programa puiede actuar sobre un 
        ' interruptor del ventilador

        Console.WriteLine("SE PONE EN MARCHA EL VENTILADOR")
        Console.WriteLine("{0} hay un exceso de {1} grados", _
    e.Mensaje, e.Desvío)
        ' suponemos que mientras esté en marcha el ventilador
        ' la temperatura baja 3 grados entre control y control
        cl.Variación = -3

    End Sub

End Module

Public Class Termostato
    ' la clase Termostato genera eventos cuando
    ' se sobrepasan los límites de temperatura

    Private m_Hora As Date
    Private m_Temp As Decimal
    Private m_Var As Decimal
    Private Const LIMITSUP As Decimal = 25D
    Private Const LIMITINF As Decimal = 21D


    Public Event ExcesoTemperatura(ByVal Sender As Termostato, _
       ByVal e As EventoDesvío)

    Public Event EscasaTemperatura(ByVal Sender As Termostato, _
          ByVal e As EventoDesvío)


    Public Sub New(ByVal aHora As Date, ByVal aTemp As Decimal)
        m_Hora = aHora
        m_Temp = aTemp
    End Sub

    ReadOnly Property Hora() As Date
        Get
            Return m_Hora
        End Get
    End Property

    ReadOnly Property Temperatura() As Decimal
        Get
            Return m_Temp
        End Get
    End Property

    Public Property Variación() As Decimal
        Get
            Return m_Var
        End Get
        Set(ByVal valor As Decimal)
            m_Var = valor
        End Set
    End Property

    Public Sub VerificarTemperatura()
        m_Temp = m_Temp + m_Var
        m_Hora = Date.Now
        Dim desvío As Decimal

        If (m_Temp > LIMITSUP) Then
            'demasiada temperatura
            desvío = m_Temp - LIMITSUP
            RaiseEvent ExcesoTemperatura(Me, _
   New EventoDesvío(desvío, "hay desvío positivo"))
        ElseIf (m_Temp < LIMITINF) Then
            'poca temperatura
            desvío = m_Temp - LIMITINF
            RaiseEvent EscasaTemperatura(Me, _
    New EventoDesvío(desvío, "hay desvío nehgativo"))
        Else
            ' rango de temperatura correcto
            ' no se genera ningún evento
        End If

    End Sub

End Class
Public Class EventoDesvío
    ' Deriva de la clase EventArgs 
    Inherits System.EventArgs

    Private m_Mensaje As String
    Private m_Desvío As Decimal

    Sub New(ByVal Desvío As Decimal, ByVal Mensaje As String)
        ' Constructor de la clase base
        MyBase.New()
        m_Mensaje = Mensaje
        m_Desvío = Desvío
    End Sub

    ReadOnly Property Mensaje() As String
        Get
            Return m_Mensaje
        End Get
    End Property

    ReadOnly Property Desvío() As Decimal
        Get
            Return m_Desvío
        End Get
    End Property

End Class

