﻿Public Class Form1
    ' Unidad15 Ej02
    ' operación de drag y drop
    ' entre controles cuadro de texto y cuadro de lista

    Public Sub New()

        ' This call is required by the Windows Form Designer.
        InitializeComponent()

        ' Add any initialization after the InitializeComponent() call.
        ' el control PictureBox no tiene la propiedad
        ' AllowDrop en la ventana de Propiedades
        ' por lo que la codificamos al crear el 
        ' objeto aplicación
        PictureBox2.AllowDrop = True

    End Sub
    Private Sub ListBox1_MouseDown(ByVal sender As Object, _
  ByVal e As System.Windows.Forms.MouseEventArgs) _
  Handles ListBox1.MouseDown


        Dim DragDropResult As DragDropEffects
        ' sólo nos interesa si el botón pulsado es
        ' el izquierdo
        If e.Button = Windows.Forms.MouseButtons.Left Then
            DragDropResult = ListBox1.DoDragDrop( _
                          ListBox1.Items(ListBox1.SelectedIndex), _
                          DragDropEffects.Move Or DragDropEffects.Copy)
            ' Si la operación es MOVE 
            ' es decir, MouseDown izquierdo sin
            ' pulsar tecla Ctrl 
            ' entonces eliminamos el elemento  
            ' de la lista de origen
            If DragDropResult = DragDropEffects.Move Then
                ListBox1.Items.RemoveAt(ListBox1.SelectedIndex)
            End If
        End If

    End Sub
    Private Sub PictureBox1_MouseDown(ByVal sender As Object, _
    ByVal e As System.Windows.Forms.MouseEventArgs) _
      Handles PictureBox1.MouseDown

        Dim DragDropResult As DragDropEffects
        ' sólo nos interesa si el botón pulsado es
        ' el izquierdo
        If e.Button = Windows.Forms.MouseButtons.Left Then
            DragDropResult = PictureBox1.DoDragDrop( _
                          PictureBox1.Image, _
                          DragDropEffects.Copy)
            ' con PictureBox1 no tomamos en cuenta MOVE
            ' todo se trata como COPY 
        End If

    End Sub
    Private Sub TextBox1_MouseDown(ByVal sender As Object, _
    ByVal e As System.Windows.Forms.MouseEventArgs) _
    Handles TextBox1.MouseDown

        Dim DragDropResult As DragDropEffects

        ' sólo nos interesa si el botón pulsado es
        ' el izquierdo
        If e.Button = Windows.Forms.MouseButtons.Left Then
            DragDropResult = TextBox1.DoDragDrop( _
                          TextBox1.Text, _
                          DragDropEffects.Move Or DragDropEffects.Copy)
            ' Si la operación es MOVE 
            ' es decir, MouseDown izquierdo sin
            ' pulsar tecla Ctrl
            ' entonces eliminamos el texto  
            ' del cuadro de texto de origen
            If DragDropResult = DragDropEffects.Move Then
                TextBox1.Text = ""
            End If
        End If

    End Sub
    Private Sub TextBox1_DragEnter(ByVal sender As Object, _
                              ByVal e As DragEventArgs) _
                              Handles TextBox1.DragEnter

        ' si se pulsa Ctrl junto con el arrastre
        ' entonces el elemento se copia
        ' en caso contrario, se mueve
        ' lo que implica que se borrará del origen
        ' en el propio evento MouseDown
        If e.KeyState = 9 Then ' tecla Control  
            e.Effect = DragDropEffects.Copy
        Else
            e.Effect = DragDropEffects.Move
        End If

    End Sub
    Private Sub TextBox1_DragDrop(ByVal sender As Object, _
                                  ByVal e As System.Windows.Forms.DragEventArgs) _
                                  Handles TextBox1.DragDrop


        TextBox1.Text = e.Data.GetData(DataFormats.Text)

        ' esto es válido:
        ' utilizamos este evento para actualizar otro control
        ' Si en los datos arrastrados 
        ' hay datos bitmap los colocaremos 
        ' en PictureBox2
        ' primero se limpia
        ' PictureBox2.Image = Nothing
        ' después se asigna
        ' PictureBox2.Image = e.Data.GetData(DataFormats.Bitmap)

    End Sub


    Private Sub ListBox2_DragEnter(ByVal sender As Object, _
                               ByVal e As DragEventArgs) _
                               Handles ListBox2.DragEnter

        ' si se pulsa Ctrl junto con el arrastre
        ' entonces el elemento se copia
        ' en caso contrario, se mueve
        ' lo que implica que se borrará del origen
        ' en el propio evento MouseDown
        If e.KeyState = 9 Then ' tecla Control   
            e.Effect = DragDropEffects.Copy
        Else
            e.Effect = DragDropEffects.Move
        End If

    End Sub
    Private Sub ListBox2_DragDrop(ByVal sender As Object, _
                                  ByVal e As System.Windows.Forms.DragEventArgs) _
                                  Handles ListBox2.DragDrop

        ListBox2.Items.Add(e.Data.GetData(DataFormats.Text))

    End Sub

    Private Sub PictureBox2_DragEnter(ByVal sender As Object, _
                                   ByVal e As DragEventArgs) _
                              Handles PictureBox2.DragEnter


        ' si se pulsa Ctrl junto con el arrastre
        ' entonces el elemento se copia
        ' en caso contrario, se mueve
        ' lo que implica que se borrará del origen
        ' en el propio evento MouseDown
        If e.KeyState = 9 Then ' tecla Control   
            e.Effect = DragDropEffects.Copy
        Else
            e.Effect = DragDropEffects.Move
        End If

    End Sub
    Private Sub PictureBox2_DragDrop(ByVal sender As Object, _
                                  ByVal e As System.Windows.Forms.DragEventArgs) _
                              Handles PictureBox2.DragDrop


        PictureBox1.Image = PictureBox2.Image
        PictureBox2.Image = e.Data.GetData(DataFormats.Bitmap)

    End Sub


End Class
