﻿Public Class Form1

    Private Sub Form1_Load(ByVal sender As Object, ByVal e As System.EventArgs) Handles Me.Load
        Me.NorthwindDataSet11.Clear()
        Me.SqlDataAdapter1.Fill(Me.NorthwindDataSet11.Customers)

        Posición()

    End Sub
    Private Sub btnPrimero_Click(ByVal sender As System.Object, _
           ByVal e As System.EventArgs) _
           Handles btnPrimero.Click

        ' navegación hasta el primer registro del conjunto de datos
        Me.BindingContext(CustomersBindingSource).Position = 0
        Posición()

    End Sub

    Private Sub btnÚltimo_Click(ByVal sender As System.Object, _
        ByVal e As System.EventArgs) _
        Handles btnÚltimo.Click

        ' navegación hasta el último registro del conjunto de datos
        Me.BindingContext(CustomersBindingSource).Position = _
            Me.BindingContext(CustomersBindingSource).Count - 1
        Posición()

    End Sub


    Private Sub BtnAdelante_Click(ByVal sender As System.Object, _
        ByVal e As System.EventArgs) _
        Handles btnAdelante.Click

        ' navegación hacia adelante
        Me.BindingContext(CustomersBindingSource).Position += 1
        Posición()

    End Sub

    Private Sub BtnAtrás_Click(ByVal sender As Object, _
        ByVal e As System.EventArgs) _
        Handles btnAtrás.Click

        ' navegación hacia atrás
        Me.BindingContext(CustomersBindingSource).Position -= 1
        Posición()

    End Sub
    Private Sub Posición()

        ' se crea el objeto BindingManagerBase
        ' a partir del objeto BindingContext 
        Dim bm As BindingManagerBase = _
            Me.BindingContext(CustomersBindingSource)
        Dim qPosición As Short

        ' controlar el posicionamiento dentro del
        ' conjunto de datos

        ' siempre la colección está basada en 0
        qPosición = bm.Position + 1
        ' actualizar la etiqueta en la interfaz
        lbPosición.Text = qPosición.ToString & "/" & bm.Count

        ' si no hay filas: no debe habilitarse
        ' el botón Eliminar ni el botón Buscar
        If bm.Count = 0 Then
            btnEliminar.Enabled = False
            btnBuscar.Enabled = False
        Else
            btnEliminar.Enabled = True
            btnBuscar.Enabled = True
        End If


    End Sub
    Private Sub Form1_FormClosing(ByVal sender As Object, _
       ByVal e As System.Windows.Forms.FormClosingEventArgs) _
       Handles Me.FormClosing

        ' si el conjunto de datos recibió cambios
        ' se actualiza el origen de datos
        Try
            If NorthwindDataSet11.HasChanges() Then
                Me.SqlDataAdapter1.Update(NorthwindDataSet11)
            End If
        Catch ex As Exception
            MsgBox(ex.Message)
        End Try

    End Sub
    Private Sub btnInsertar_Click(ByVal sender As System.Object, _
       ByVal e As System.EventArgs) _
       Handles btnInsertar.Click

        Dim Tabla As DataTable = NorthwindDataSet11.Customers
        Dim Filas As DataRowCollection = Tabla.Rows
        Dim Fila As DataRow

        ' Inserción de una fila casi vacía 
        Try
            ' se crea una fila nueva
            Fila = Tabla.NewRow

            ' se da un valor inicial a los campos
            Fila("CustomerID") = ""
            Fila("CompanyName") = ""
            Fila("ContactName") = ""
            Fila("ContactTitle") = ""
            Fila("City") = ""

            ' se añade la fila a la colección Filas de la tabla
            ' Empresas del conjunto de datos NorthwindDataSet11
            Filas.Add(Fila)

            ' posicionamiento al final del conjunto de datos
            BindingContext(CustomersBindingSource).Position = _
                BindingContext(CustomersBindingSource).Count - 1

            Posición()

            ' se coloca el foco en el primer campo 
            ' de entrada de datos
            tbID.Focus()

        Catch ex As System.Data.ConstraintException
            ' pueden generarse excepciones:
            ' principalmente para gestionar las claves duplicadas
            ' o los campos obligatorios que queden vacíos
            MsgBox(ex.Message)
        End Try


    End Sub
    Private Sub btnEliminar_Click(ByVal sender As System.Object, _
        ByVal e As System.EventArgs) _
        Handles btnEliminar.Click

        ' se crea el objeto BindingManagerBase
        ' a partir del objeto BindingContext 
        Dim bm As BindingManagerBase = _
   Me.BindingContext(CustomersBindingSource)

        Dim Fila As DataRowView
        ' eliminación de la fila vigente del conjunto
        ' de datos
        Try
            Fila = bm.Current
            Fila.Row.Delete()
            Posición()
        Catch ex As Exception
            MsgBox(ex.Message)
        End Try


    End Sub
    Private Sub btnBuscar_Click( _
     ByVal sender As System.Object, _
         ByVal e As System.EventArgs) _
         Handles btnBuscar.Click

        Dim Tabla As DataTable = NorthwindDataSet11.Customers
        Dim Filas As DataRowCollection = Tabla.Rows
        Dim Fila() As DataRow

        Dim strSQL As String = "CustomerID Like '" & _
            tbBuscar.Text & "*'"

        ' en la matriz Fila() quedan las filas que cumplen
        ' con el criterio de búsqueda
        Fila = Tabla.Select(strSQL)


        If (Fila.GetUpperBound(0) = -1) Then
            ' si no hay elementos  
            MsgBox("No existen clientes con ese nombre")
            Exit Sub
        End If
        Dim i As Integer
        If (Fila.GetUpperBound(0) = 0) Then
            ' hay un elemento
            For i = 0 To Filas.Count - 1
                ' buscar el índice en la colección Filas
                If (Filas(i).Equals(Fila(0))) Then
                    ' posiciona el conjunto de datos
                    ' para visualizar los datos de la
                    ' empresa buscada
                    Me.BindingContext(CustomersBindingSource).Position = i
                    Posición()
                    Exit Sub
                End If
            Next
        Else
            ' aquí se podría mostrar una ListBox con 
            ' todas las empresas
            ' que cumplen el criterio
            ' pero para simplificar damos este mensaje
            MsgBox("Hay más de un cliente que empieza " & _
     " con ese nombre")
        End If


    End Sub
End Class
