﻿Public Class Form1

    Private Sub Form1_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load

    End Sub

    Private Sub Button1_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button1.Click
        ' LINQ to XML
        ' generamos una fuente de datos a partir de un archivo 
        ' de texto con datos XML
        Dim docxml As XDocument = XDocument.Load("...\...\TextFile1.txt")

        ' Declaramos una variable para obtener los datos del
        ' documento XML que cumplen la condición
        ' alumnos con edad <> a 19 años
        Dim alumnosSeleccionados = _
         From lista In docxml.Descendants("alumno") _
         Where lista.Element("edad").Value <> "19" _
         Select lista.Element("nombre").Value

        ' Declaramos una variable para obtener el resultado
        Dim resultado As String = ""

        ' Recorremos los resultados de la condición 
        For Each elemento In alumnosSeleccionados
            resultado &= elemento & vbCrLf
        Next

        ' Mostramos el resultado final
        MessageBox.Show("Alumnos edad <> 19 " & vbCrLf & resultado)
    End Sub

    Private Sub Button2_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button2.Click
        ' LINQ to XML
        ' generamos una fuente de datos a partir de una declaración
        ' literal dentro del código VB
        Dim curso As XElement = _
         <curso>
             <alumno>
                 <nombre>Juan Costa</nombre>
                 <edad>21</edad>
                 <sexo>H</sexo>
             </alumno>
             <alumno>
                 <nombre>José García</nombre>
                 <edad>19</edad>
                 <sexo>H</sexo>
             </alumno>
             <alumno>
                 <nombre>María Rodríguez</nombre>
                 <edad>18</edad>
                 <sexo>M</sexo>
             </alumno>
             <alumno>
                 <nombre>Luisa González</nombre>
                 <edad>19</edad>
                 <sexo>M</sexo>
             </alumno>
         </curso>

        ' Declaramos una variable para obtener los datos del
        ' documento XML que cumplen la condición
        ' se seleccionan los varones del curso
        Dim alumnosSeleccionados = _
         From lista In curso.Elements() _
         Where lista.Element("sexo").Value = "H" _
         Select lista.Element("nombre").Value


        ' Declaramos una variable para obtener el resultado
        Dim resultado As String = ""

        ' Recorremos los resultados de la condición  
        For Each elemento In alumnosSeleccionados
            resultado &= elemento & vbCrLf
        Next

        ' Mostramos el resultado final
        MessageBox.Show("Alumnos varones" & vbCrLf & resultado)
    End Sub

    Private Sub Button3_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button3.Click
        ' LINQ to XML
        ' generamos una fuente de datos a partir de una declaración
        ' literal dentro del código VB
        Dim curso As XElement = _
         <curso>
             <alumno>
                 <nombre>Juan Costa</nombre>
                 <edad>21</edad>
                 <sexo>H</sexo>
             </alumno>
             <alumno>
                 <nombre>José García</nombre>
                 <edad>19</edad>
                 <sexo>H</sexo>
             </alumno>
             <alumno>
                 <nombre>María Rodríguez</nombre>
                 <edad>18</edad>
                 <sexo>M</sexo>
             </alumno>
             <alumno>
                 <nombre>Luisa González</nombre>
                 <edad>19</edad>
                 <sexo>M</sexo>
             </alumno>
         </curso>

        ' Transformación del documento XML
        Dim nuevo = _
        New XElement("CursoAdicional", _
        From lista In curso.Elements("alumno") _
          Select New XElement("persona", _
                 lista.Element("nombre"), _
                 lista.Element("sexo")))

        nuevo.Save("nuevo.xml")

   
    End Sub
End Class
