﻿Public Class Categoria
    Implements IEnumerable
    Private _Categoria As String
    Private _Producto() As Producto
    Property Categoria() As String
        Get
            Return _Categoria
        End Get
        Set(ByVal value As String)
            _Categoria = value
        End Set
    End Property
    Public Function GetEnumerator() As IEnumerator _
         Implements IEnumerable.GetEnumerator

        Return New ProductoEnum(_Producto)
    End Function
    Public Sub New(ByVal pArray() As Producto)
        _Producto = New Producto(pArray.Length - 1) {}

        Dim i As Integer
        For i = 0 To pArray.Length - 1
            _Producto(i) = pArray(i)
        Next i
    End Sub

End Class
Public Class ProductoEnum
    Implements IEnumerator

    Public _Producto() As Producto

    ' Posicionar el numerador antes de la 1ra posición
    ' hasta realizar el primer MoveNext() 
    Dim position As Integer = -1

    Public Sub New(ByVal list() As Producto)
        _Producto = list
    End Sub

    Public Function MoveNext() As Boolean Implements IEnumerator.MoveNext
        position = position + 1
        Return (position < _Producto.Length)
    End Function

    Public Sub Reset() Implements IEnumerator.Reset
        position = -1
    End Sub

    Public ReadOnly Property Current() As Object Implements IEnumerator.Current
        Get
            Try
                Return _Producto(position)
            Catch ex As IndexOutOfRangeException
                Throw New InvalidOperationException()
            End Try
        End Get
    End Property
End Class
Public Class Producto

    Private _Nombre As String
    Private _Categoria As String
    Private _Stock As Integer
    Private _Precio As Integer
    Property Nombre() As String
        Get
            Return _Nombre
        End Get
        Set(ByVal value As String)
            _Nombre = value
        End Set
    End Property
    Property Categoría() As String
        Get
            Return _Categoria
        End Get
        Set(ByVal value As String)
            _Categoria = value
        End Set
    End Property
    Property Stock() As Integer
        Get
            Return _Stock
        End Get
        Set(ByVal value As Integer)
            _Stock = value
        End Set
    End Property
    Property Precio() As Integer
        Get
            Return _Precio
        End Get
        Set(ByVal value As Integer)
            _Precio = value
        End Set
    End Property



End Class


